execute as @a unless data storage healthbar installed run function healthbar:load

# --------------------------------------------------------------------------------- #

execute as @a if score @s HB.settings matches 1.. run function healthbar:settings/open

# --------------------------------------------------------------------------------- #

execute if score #hostile_healthbar HB.settings matches 1 as @a[advancements={healthbar:hit_mob=false}] as @e[distance=..30, type=#healthbar:hostile, predicate=healthbar:hit, tag=Healthbar, tag=!Healthbar.exclude] run function healthbar:display/update
execute if score #passive_healthbar HB.settings matches 1 as @a[advancements={healthbar:hit_mob=false}] as @e[distance=..30, type=#healthbar:passive, predicate=healthbar:hit, tag=Healthbar, tag=!Healthbar.exclude] run function healthbar:display/update

# --------------------------------------------------------------------------------- #

execute as @a[advancements={healthbar:hit_mob=true}] at @s run function healthbar:init/hit_registration

# --------------------------------------------------------------------------------- #

# Detect mobs in range and create healthbars for them
execute if score #hostile_healthbar HB.settings matches 1 as @a at @s as @e[distance=..30, type=#healthbar:hostile, tag=!Healthbar, tag=!Healthbar.exclude] run function healthbar:init/new_mob
execute if score #passive_healthbar HB.settings matches 1 as @a at @s as @e[distance=..30, type=#healthbar:passive, tag=!Healthbar, tag=!Healthbar.exclude] run function healthbar:init/new_mob

# Detect if mobs are out of range and remove their healthbars
execute if score #hostile_healthbar HB.settings matches 1 as @a at @s as @e[distance=31.., type=#healthbar:hostile, tag=Healthbar, tag=!Healthbar.exclude] run function healthbar:init/out_of_range
execute if score #passive_healthbar HB.settings matches 1 as @a at @s as @e[distance=31.., type=#healthbar:passive, tag=Healthbar, tag=!Healthbar.exclude] run function healthbar:init/out_of_range

# --------------------------------------------------------------------------------- #

execute as @e[type=text_display, tag=DamageDisplay] run scoreboard players remove @s HB.temp 1
kill @e[type=text_display, tag=DamageDisplay, scores={HB.temp=..0}]

# --------------------------------------------------------------------------------- #

# Remove unnecessary text displays
execute store result score #TextDisplays HB.temp run execute if entity @e[type=text_display, tag=HealthDisplay]
execute unless score #TextDisplays HB.temp matches 1 run tellraw @a [{"text":"[Better Healthbar] ","color":"gold"},{"text":"Fixed Healthbar Error","color":"red"}]
execute unless score #TextDisplays HB.temp matches 1 run kill @e[type=text_display, tag=HealthDisplay]
execute unless score #TextDisplays HB.temp matches 1 run summon text_display 0 -60 0 {alignment:"center", Tags:["HealthDisplay"]}

# --------------------------------------------------------------------------------- #

tag @a remove Attacker
scoreboard players enable @s HB.settings